#include "..\STM8driver\stm8l10x.h"
#include "..\STM8driver\stm8l10x_conf.h"
//------------------------------------------------------------------------------
#define led_off GPIO_SetBits(GPIOB, GPIO_Pin_0)
#define led_on GPIO_ResetBits(GPIOB, GPIO_Pin_0)

u8 led_flag=0;
int num;

u8 uart_test(u8 data)
{
  while(USART_GetFlagStatus(USART_FLAG_TXE)==RESET);
  USART_SendData8(data);
  return data;
}

void exit_init(void)
{

  GPIO_Init(GPIOB, GPIO_Pin_1, GPIO_Mode_In_PU_IT);//KEY1
  EXTI_DeInit();
  EXTI_SetPinSensitivity(EXTI_Pin_1,EXTI_Trigger_Rising);
}

void SClK_Initial(void)
{
  CLK_MasterPrescalerConfig(CLK_MasterPrescaler_HSIDiv1); // 16M
}

void uart_init(void)
{
  USART_DeInit();
  CLK_PeripheralClockConfig(CLK_Peripheral_USART,ENABLE);
  USART_Init(9600, USART_WordLength_8D,USART_StopBits_1, USART_Parity_No, (USART_Mode_TypeDef)(USART_Mode_Tx|USART_Mode_Rx));
  USART_Cmd(ENABLE);
  
}


void GPIO_Initial(void)
{    
    GPIO_Init(GPIOB, GPIO_Pin_0, GPIO_Mode_Out_PP_High_Slow);//LED*
    GPIO_SetBits(GPIOB, GPIO_Pin_0);
}

void SPI_Initial(void)
{
    SPI_DeInit();

    GPIO_Init(GPIOA, GPIO_Pin_3, GPIO_Mode_In_PU_No_IT);//4432_IRQ*
    GPIO_Init(GPIOC, GPIO_Pin_4, GPIO_Mode_Out_PP_High_Slow);//4432_SDN
    
    GPIO_Init(GPIOB, GPIO_Pin_4, GPIO_Mode_Out_PP_High_Slow);//4432_nsel
    GPIO_SetBits(GPIOB, GPIO_Pin_4);

	GPIO_Init(GPIOB, GPIO_Pin_7, GPIO_Mode_In_PU_No_IT);       // MISO (PB7)
	GPIO_Init(GPIOB, GPIO_Pin_5, GPIO_Mode_Out_PP_High_Slow);  // SCLK (PB5)
	GPIO_Init(GPIOB, GPIO_Pin_6, GPIO_Mode_Out_PP_High_Slow);  // MOSI (PB6)
        
              
	CLK_PeripheralClockConfig(CLK_Peripheral_SPI, ENABLE);
	
        SPI_DeInit();
	SPI_Init(SPI_FirstBit_MSB, SPI_BaudRatePrescaler_64,
             SPI_Mode_Master, SPI_CPOL_Low, SPI_CPHA_1Edge,
             SPI_Direction_2Lines_FullDuplex, SPI_NSS_Soft);

	SPI_Cmd(ENABLE);
	

}


void TIM3_Init(void)
{
    TIM3_DeInit();

    CLK_PeripheralClockConfig(CLK_Peripheral_TIM3, ENABLE);

    TIM3_TimeBaseInit(TIM3_Prescaler_16, TIM3_CounterMode_Up, 1005);
    TIM3_ITConfig(TIM3_IT_Update, ENABLE);

    TIM3_Cmd(ENABLE);
}

void led_flash()
{
  if(led_flag==0)
  {
    led_on;
    led_flag=1;
  }
  else
  {
    led_off;
    led_flag=0;
  }
}

/*******************************************************************************
                                 SPI
*******************************************************************************/
u8 SPI_ExchangeByte(u8 data)
{
	uint8_t spidata = 0;
	
        SPI_SendData( data );	//
	while(RESET == SPI_GetFlagStatus( SPI_FLAG_TXE ));		//ȴͻ
	
	while( RESET == SPI_GetFlagStatus( SPI_FLAG_RXNE ) );	//ȴջǿ
	spidata = SPI_ReceiveData( );
	return spidata;	//
}

uint8_t drv_spi_read_write_byte( uint8_t TxByte )
{
	uint8_t spidata = 0;	
        SPI_SendData( TxByte );	//
	while(RESET == SPI_GetFlagStatus( SPI_FLAG_TXE ));		//ȴͻ
	
	while( RESET == SPI_GetFlagStatus( SPI_FLAG_RXNE ) );	//ȴջǿ
	spidata = SPI_ReceiveData( );
	return spidata;	//
}

/*******************************************************************************
                                SI4432
*******************************************************************************/
//------------------------------------------------------------------------------
uint8_t SI4432_Read_Reg( uint8_t ReadAddr );
void SI4432_Write_Reg( uint8_t WriteAddr, uint8_t WriteValue );
uint8_t SI4432_Get_It_Status1( void );
uint8_t SI4432_Get_It_Status2( void );
void SI4432_Tx_Packet( uint8_t *pTxBuff, uint8_t TxLength );
uint8_t SI4432_Rx_Packet( uint8_t *pRxBuff );
void SI4432_Gpio_Init( void );
void SI4432_Init( void );
#define SI4432_DATA_LEN_MAX			64
#define SI_SET_CSN_HIGH( )			GPIO_SetBits(GPIOB, GPIO_Pin_4)
#define SI_SET_CSN_LOW( )			GPIO_ResetBits(GPIOB, GPIO_Pin_4)
#define SI_GET_IRQ_STATUS( )		(( GPIOA->IDR & GPIO_Pin_3 )== GPIO_Pin_3 ) ? 0 : 1
#define SI4432_Tx_Byte( TxByte )	drv_spi_read_write_byte( TxByte )
#define SI4432_Rx_Byte( x )		drv_spi_read_write_byte( x )	
//------------------------------------------------------------------------------
uint8_t g_Status1 = 0, g_Status2 = 0;

void drv_delay_ms(u8 t)
{
  int i;
  for(;t>0;t--)
  {
  for(i=2380;i>0;i--)
  {
  ;
  }
  }
}

uint8_t SI4432_Read_Reg( uint8_t ReadAddr )
{
	uint8_t l_ReadValue = 0;
	
	SI_SET_CSN_LOW( );
        drv_delay_ms(1);
	SI4432_Tx_Byte( ReadAddr );
	l_ReadValue = SI4432_Rx_Byte( 0xff );
        drv_delay_ms(1);
	SI_SET_CSN_HIGH( );
	return l_ReadValue;
}


void SI4432_Write_Reg( uint8_t WriteAddr, uint8_t WriteValue )
{
	SI_SET_CSN_LOW( );
        drv_delay_ms(1);
	SI4432_Tx_Byte( WriteAddr | 0x80 );
	SI4432_Tx_Byte( WriteValue );
        drv_delay_ms(1);
	SI_SET_CSN_HIGH( );
        
}


uint8_t SI4432_Get_It_Status1( void )
{
	return ( SI4432_Read_Reg( 0x03 ));
}


uint8_t SI4432_Get_It_Status2( void )
{
	return ( SI4432_Read_Reg( 0x04 ));
}


void SI4432_Tx_Packet( uint8_t *pTxBuff, uint8_t TxLength )
{
        led_off;
	SI4432_Write_Reg( 0x07, 0x01 );			//Ԥģʽ       
        drv_delay_ms(10);
	SI4432_Write_Reg( 0x3E, TxLength );		//д뷢ݸ
	while( TxLength-- )
	{
		SI4432_Write_Reg( 0x7F, *pTxBuff );	//д뷢
		pTxBuff++;
	}
        
	drv_delay_ms(20);
            SI4432_Get_It_Status1( );
            SI4432_Get_It_Status2( );	
	SI4432_Write_Reg( 0x07, 0x09 );			//
	
	while( !SI_GET_IRQ_STATUS( ))		//IRQ״̬Ϊ,ɱ־
        {
          
        }
        g_Status1 = SI4432_Get_It_Status1( );
	g_Status2 = SI4432_Get_It_Status2( );
        led_on;
}


uint8_t SI4432_Rx_Packet( uint8_t *pRxBuff )
{
	uint8_t i = 0, l_Length = 0;
	if( SI_GET_IRQ_STATUS( ))
	{
		SI4432_Write_Reg( 0x07, 0x01 );				//ؽͨ
                drv_delay_ms(10);
                led_on;		

		g_Status1 = SI4432_Get_It_Status1( );
		g_Status2 = SI4432_Get_It_Status2( );		
		
		if(( g_Status1 & 0x01) == 0x01 )
		{
			//CRCжϱ־λ1 RX FIFO 
			SI4432_Write_Reg(0x08, 0x02);										
			SI4432_Write_Reg(0x08, 0x00);							
		}
		
		if(( g_Status1 & 0x02) == 0x02 )
		{
			//жϱ־λ1
			l_Length = SI4432_Read_Reg( 0x4B );
			
			if( l_Length < SI4432_DATA_LEN_MAX )
			{
				for( i = 0; i < l_Length; i++ )
				{
                                    pRxBuff[ i ] = SI4432_Read_Reg( 0x7F );
				}
			}
		}
		//RX FIFO
		SI4432_Write_Reg( 0x08, 0x02 );													
		SI4432_Write_Reg( 0x08, 0x00 );
                SI4432_Write_Reg(0x07, 0x05);
	}
	return l_Length;
}


void SI4432_Gpio_Init( void )
{
  GPIO_Init( GPIOC, GPIO_Pin_0 , GPIO_Mode_In_PU_No_IT  );//GPIO0
  GPIO_Init( GPIOC, GPIO_Pin_1, GPIO_Mode_In_PU_No_IT  );//GPIO1
  GPIO_Init( GPIOC, GPIO_Pin_2, GPIO_Mode_In_PU_No_IT  );//GPIO2
  GPIO_Init( GPIOC, GPIO_Pin_3, GPIO_Mode_In_PU_No_IT  );//GPIO3
}


void SI4432_Init( void )
{      
	GPIO_ResetBits(GPIOC, GPIO_Pin_4);
        drv_delay_ms( 50 );
	
	g_Status1 = SI4432_Get_It_Status1( );
	g_Status2 = SI4432_Get_It_Status2( );
	
	SI4432_Write_Reg( 0x07, 0x80 );		//SWλ
	
        while(  !SI_GET_IRQ_STATUS( ))	
	{
		drv_delay_ms( 1 );
		if(0)
		{
			break;
		}
	}
	g_Status1 = SI4432_Get_It_Status1( );
	g_Status2 = SI4432_Get_It_Status2( );
	
	while(  SI_GET_IRQ_STATUS( ))	
	{
		drv_delay_ms( 1 );
		if(0)
		{
			break;
		}
	}
	
	//Ƶ
	SI4432_Write_Reg( 0x75, 0x53 );
	SI4432_Write_Reg( 0x76, 0x42 );
	SI4432_Write_Reg( 0x77, 0xf0 );
        SI4432_Write_Reg( 0x79, 0x01 );
        SI4432_Write_Reg( 0x7A, 0x21 );
	
	SI4432_Write_Reg( 0x2A, 0x14 );	
	SI4432_Write_Reg( 0x6E, 0x09 );
	SI4432_Write_Reg( 0x6F, 0xd5 );
	SI4432_Write_Reg( 0x70, 0x2C );	
        SI4432_Write_Reg( 0x72, 0x06 );
	SI4432_Write_Reg( 0x1C, 0x1b );						
	SI4432_Write_Reg( 0x20, 0x83 );					
	SI4432_Write_Reg( 0x21, 0xc0 );					
	SI4432_Write_Reg( 0x22, 0x13 );					
	SI4432_Write_Reg( 0x23, 0xa9 );						
	SI4432_Write_Reg( 0x24, 0x00 );						
	SI4432_Write_Reg( 0x25, 0x03 );					
	SI4432_Write_Reg( 0x1D, 0x40 );						
	SI4432_Write_Reg( 0x1E, 0x0A );					
	SI4432_Write_Reg( 0x2A, 0x14 );						
	SI4432_Write_Reg( 0x34, 0x0A );	
	SI4432_Write_Reg( 0x35, 0x2A );			
	SI4432_Write_Reg( 0x33, 0x02 );	  
	SI4432_Write_Reg( 0x36, 0x2D );				
	SI4432_Write_Reg( 0x37, 0xD4 );					
	SI4432_Write_Reg( 0x30, 0x8D );				
	SI4432_Write_Reg( 0x32, 0x00 );	
	SI4432_Write_Reg( 0x71, 0x63 );				
	SI4432_Write_Reg( 0x0B, 0x12 );				
	SI4432_Write_Reg( 0x0C, 0x15 );								
	
	SI4432_Write_Reg( 0x09, 0x78 );				//õ				
	SI4432_Write_Reg( 0x69, 0x60 );	
	SI4432_Write_Reg( 0x6d, 0x1f );					 
	SI4432_Write_Reg( 0x07, 0x05 );				
	SI4432_Write_Reg( 0x05, 0x03 ); 			
	SI4432_Write_Reg( 0x06, 0x00 ); 			
	g_Status1 = SI4432_Get_It_Status1( );		
	g_Status2 = SI4432_Get_It_Status2( );		
    
	SI4432_Write_Reg( 0x07, 0x05 );	
	SI4432_Write_Reg( 0x0d, 0xf4 );	

}